#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

// funzione di utilità per stampe di debugging
int debug(char *str, ...) {
    const char dbg[]="DBG: ";
    va_list argp;
    size_t size = strlen(str)+strlen(dbg)+1024;
    char * p=malloc(size);
    assert(p);
    strncpy(p,dbg,strlen(dbg));
    strcpy(p+strlen(dbg), str);
    va_start(argp, str);
    vsnprintf(p, size, str, argp);
    va_end(argp);
    fprintf(stderr, "%s", p);
    free(p);
}

int main () {
    debug("msg %s %d\n", "MESSAGGIO",1);
    debug("msg diverso %d %d\n", 1,1);
    return 0;
}
